<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_65) on Fri Aug 22 15:06:28 CEST 2014 -->
<title>WebSocketServer</title>
<meta name="date" content="2014-08-22">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="WebSocketServer";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketServer.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/java_websocket/server/DefaultWebSocketServerFactory.html" title="class in org.java_websocket.server"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/server/WebSocketServer.html" target="_top">Frames</a></li>
<li><a href="WebSocketServer.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket.server</div>
<h2 title="Class WebSocketServer" class="title">Class WebSocketServer</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">org.java_websocket.WebSocketAdapter</a></li>
<li>
<ul class="inheritance">
<li>org.java_websocket.server.WebSocketServer</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.lang.Runnable, <a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../fr/inria/alpage/frmgcm/server/FRMGWebSocketServer.html" title="class in fr.inria.alpage.frmgcm.server">FRMGWebSocketServer</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="strong">WebSocketServer</span>
extends <a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a>
implements java.lang.Runnable</pre>
<div class="block"><tt>WebSocketServer</tt> is an abstract class that only takes care of the
 HTTP handshake portion of WebSockets. It's up to a subclass to add
 functionality/purpose to the server.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Class and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static interface&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server">WebSocketServer.WebSocketServerFactory</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.WebSocketWorker.html" title="class in org.java_websocket.server">WebSocketServer.WebSocketWorker</a></strong></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#address">address</a></strong></code>
<div class="block">The port number that this WebSocket server should listen on.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.concurrent.BlockingQueue&lt;java.nio.ByteBuffer&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#buffers">buffers</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.Collection&lt;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#connections">connections</a></strong></code>
<div class="block">Holds the list of active WebSocket connections.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.List&lt;<a href="../../../org/java_websocket/server/WebSocketServer.WebSocketWorker.html" title="class in org.java_websocket.server">WebSocketServer.WebSocketWorker</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#decoders">decoders</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#DECODERS">DECODERS</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#drafts">drafts</a></strong></code>
<div class="block">The Draft of the WebSocket protocol the Server is adhering to.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.List&lt;<a href="../../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket">WebSocketImpl</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#iqueue">iqueue</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.concurrent.atomic.AtomicBoolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#isclosed">isclosed</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#queueinvokes">queueinvokes</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.concurrent.atomic.AtomicInteger</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#queuesize">queuesize</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.nio.channels.Selector</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#selector">selector</a></strong></code>
<div class="block">The 'Selector' used to get event keys from the underlying socket.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.lang.Thread</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#selectorthread">selectorthread</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.nio.channels.ServerSocketChannel</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#server">server</a></strong></code>
<div class="block">The socket channel for this WebSocket server.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server">WebSocketServer.WebSocketServerFactory</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#wsf">wsf</a></strong></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer()">WebSocketServer</a></strong>()</code>
<div class="block">Creates a WebSocketServer that will attempt to
 listen on port <var>WebSocket.DEFAULT_PORT</var>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress)">WebSocketServer</a></strong>(java.net.InetSocketAddress&nbsp;address)</code>
<div class="block">Creates a WebSocketServer that will attempt to bind/listen on the given <var>address</var>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int)">WebSocketServer</a></strong>(java.net.InetSocketAddress&nbsp;address,
               int&nbsp;decoders)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List)">WebSocketServer</a></strong>(java.net.InetSocketAddress&nbsp;address,
               int&nbsp;decodercount,
               java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)">WebSocketServer</a></strong>(java.net.InetSocketAddress&nbsp;address,
               int&nbsp;decodercount,
               java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts,
               java.util.Collection&lt;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&gt;&nbsp;connectionscontainer)</code>
<div class="block">Creates a WebSocketServer that will attempt to bind/listen on the given <var>address</var>,
 and comply with <tt>Draft</tt> version <var>draft</var>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20java.util.List)">WebSocketServer</a></strong>(java.net.InetSocketAddress&nbsp;address,
               java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#addConnection(org.java_websocket.WebSocket)">addConnection</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#allocateBuffers(org.java_websocket.WebSocket)">allocateBuffers</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;c)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.util.Collection&lt;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#connections()">connections</a></strong>()</code>
<div class="block">Returns a WebSocket[] of currently connected clients.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#createBuffer()">createBuffer</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getAddress()">getAddress</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getDraft()">getDraft</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getFlashSecurityPolicy()">getFlashSecurityPolicy</a></strong>()</code>
<div class="block">Gets the XML string that should be returned if a client requests a Flash
 security policy.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getLocalSocketAddress(org.java_websocket.WebSocket)">getLocalSocketAddress</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getPort()">getPort</a></strong>()</code>
<div class="block">Gets the port number that this server listens on.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getRemoteSocketAddress(org.java_websocket.WebSocket)">getRemoteSocketAddress</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.net.Socket</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getSocket(org.java_websocket.WebSocket)">getSocket</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../org/java_websocket/WebSocketFactory.html" title="interface in org.java_websocket">WebSocketFactory</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#getWebSocketFactory()">getWebSocketFactory</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#handleFatal(org.java_websocket.WebSocket,%20java.lang.Exception)">handleFatal</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
           java.lang.Exception&nbsp;e)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#handleIOException(java.nio.channels.SelectionKey,%20org.java_websocket.WebSocket,%20java.io.IOException)">handleIOException</a></strong>(java.nio.channels.SelectionKey&nbsp;key,
                 <a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                 java.io.IOException&nbsp;ex)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onClose</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
       int&nbsp;code,
       java.lang.String&nbsp;reason,
       boolean&nbsp;remote)</code>
<div class="block">Called after the websocket connection has been closed.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">onCloseInitiated</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                int&nbsp;code,
                java.lang.String&nbsp;reason)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onClosing</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
         int&nbsp;code,
         java.lang.String&nbsp;reason,
         boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onConnect(java.nio.channels.SelectionKey)">onConnect</a></strong>(java.nio.channels.SelectionKey&nbsp;key)</code>
<div class="block">Returns whether a new connection shall be accepted or not.<br>
 Therefore method is well suited to implement some kind of connection limitation.<br></div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onError(org.java_websocket.WebSocket,%20java.lang.Exception)">onError</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
       java.lang.Exception&nbsp;ex)</code>
<div class="block">Called when errors occurs.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onFragment</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
          <a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;fragment)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">onMessage</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
         java.nio.ByteBuffer&nbsp;message)</code>
<div class="block">Callback for binary messages received from the remote host</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onMessage(org.java_websocket.WebSocket,%20java.lang.String)">onMessage</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
         java.lang.String&nbsp;message)</code>
<div class="block">Callback for string messages received from the remote host</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake)">onOpen</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
      <a href="../../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;handshake)</code>
<div class="block">Called after an opening handshake has been performed and the given websocket is ready to be written on.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClose</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                int&nbsp;code,
                java.lang.String&nbsp;reason,
                boolean&nbsp;remote)</code>
<div class="block">Called after <tt>WebSocket#close</tt> is explicity called, or when the
 other end of the WebSocket connection is closed.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">onWebsocketCloseInitiated</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                         int&nbsp;code,
                         java.lang.String&nbsp;reason)</code>
<div class="block">send when this peer sends a close handshake</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClosing</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  int&nbsp;code,
                  java.lang.String&nbsp;reason,
                  boolean&nbsp;remote)</code>
<div class="block">called as soon as no further frames are accepted</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketError(org.java_websocket.WebSocket,%20java.lang.Exception)">onWebsocketError</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                java.lang.Exception&nbsp;ex)</code>
<div class="block">Called if an exception worth noting occurred.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../org/java_websocket/handshake/ServerHandshakeBuilder.html" title="interface in org.java_websocket.handshake">ServerHandshakeBuilder</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeReceivedAsServer</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                    <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft,
                                    <a href="../../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request)</code>
<div class="block">This default implementation does not do anything.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">onWebsocketMessage</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  java.nio.ByteBuffer&nbsp;blob)</code>
<div class="block">Called when an entire binary frame has been received.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.lang.String)">onWebsocketMessage</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  java.lang.String&nbsp;message)</code>
<div class="block">Called when an entire text frame has been received.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                          <a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</code>
<div class="block"><strong>Deprecated.</strong>&nbsp;</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWebsocketOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.Handshakedata)">onWebsocketOpen</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
               <a href="../../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;handshake)</code>
<div class="block">Called after <var>onHandshakeReceived</var> returns <var>true</var>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#onWriteDemand(org.java_websocket.WebSocket)">onWriteDemand</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;w)</code>
<div class="block">This method is used to inform the selector thread that there is data queued to be written to the socket.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#pushBuffer(java.nio.ByteBuffer)">pushBuffer</a></strong>(java.nio.ByteBuffer&nbsp;buf)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#queue(org.java_websocket.WebSocketImpl)">queue</a></strong>(<a href="../../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket">WebSocketImpl</a>&nbsp;ws)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#releaseBuffers(org.java_websocket.WebSocket)">releaseBuffers</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;c)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#removeConnection(org.java_websocket.WebSocket)">removeConnection</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws)</code>
<div class="block">This method performs remove operations on the connection and therefore also gives control over whether the operation shall be synchronized</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#run()">run</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#setWebSocketFactory(org.java_websocket.server.WebSocketServer.WebSocketServerFactory)">setWebSocketFactory</a></strong>(<a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server">WebSocketServer.WebSocketServerFactory</a>&nbsp;wsf)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#start()">start</a></strong>()</code>
<div class="block">Starts the server selectorthread that binds to the currently set port number and
 listeners for WebSocket connection requests.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#stop()">stop</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#stop(int)">stop</a></strong>(int&nbsp;timeout)</code>
<div class="block">Closes all connected clients sockets, then closes the underlying
 ServerSocketChannel, effectively killing the server socket selectorthread,
 freeing the port the server was bound to and stops all internal workerthreads.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/server/WebSocketServer.html#takeBuffer()">takeBuffer</a></strong>()</code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.java_websocket.WebSocketAdapter">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.java_websocket.<a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a></h3>
<code><a href="../../../org/java_websocket/WebSocketAdapter.html#getFlashPolicy(org.java_websocket.WebSocket)">getFlashPolicy</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeReceivedAsClient(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake,%20org.java_websocket.handshake.ServerHandshake)">onWebsocketHandshakeReceivedAsClient</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeSentAsClient(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeSentAsClient</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketPing(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketPing</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketPong(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketPong</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="DECODERS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DECODERS</h4>
<pre>public static&nbsp;int DECODERS</pre>
</li>
</ul>
<a name="connections">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connections</h4>
<pre>private final&nbsp;java.util.Collection&lt;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&gt; connections</pre>
<div class="block">Holds the list of active WebSocket connections. "Active" means WebSocket
 handshake is complete and socket can be written to, or read from.</div>
</li>
</ul>
<a name="address">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>address</h4>
<pre>private final&nbsp;java.net.InetSocketAddress address</pre>
<div class="block">The port number that this WebSocket server should listen on. Default is
 WebSocket.DEFAULT_PORT.</div>
</li>
</ul>
<a name="server">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>server</h4>
<pre>private&nbsp;java.nio.channels.ServerSocketChannel server</pre>
<div class="block">The socket channel for this WebSocket server.</div>
</li>
</ul>
<a name="selector">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selector</h4>
<pre>private&nbsp;java.nio.channels.Selector selector</pre>
<div class="block">The 'Selector' used to get event keys from the underlying socket.</div>
</li>
</ul>
<a name="drafts">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>drafts</h4>
<pre>private&nbsp;java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt; drafts</pre>
<div class="block">The Draft of the WebSocket protocol the Server is adhering to.</div>
</li>
</ul>
<a name="selectorthread">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectorthread</h4>
<pre>private&nbsp;java.lang.Thread selectorthread</pre>
</li>
</ul>
<a name="isclosed">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isclosed</h4>
<pre>private volatile&nbsp;java.util.concurrent.atomic.AtomicBoolean isclosed</pre>
</li>
</ul>
<a name="decoders">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decoders</h4>
<pre>private&nbsp;java.util.List&lt;<a href="../../../org/java_websocket/server/WebSocketServer.WebSocketWorker.html" title="class in org.java_websocket.server">WebSocketServer.WebSocketWorker</a>&gt; decoders</pre>
</li>
</ul>
<a name="iqueue">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>iqueue</h4>
<pre>private&nbsp;java.util.List&lt;<a href="../../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket">WebSocketImpl</a>&gt; iqueue</pre>
</li>
</ul>
<a name="buffers">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>buffers</h4>
<pre>private&nbsp;java.util.concurrent.BlockingQueue&lt;java.nio.ByteBuffer&gt; buffers</pre>
</li>
</ul>
<a name="queueinvokes">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>queueinvokes</h4>
<pre>private&nbsp;int queueinvokes</pre>
</li>
</ul>
<a name="queuesize">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>queuesize</h4>
<pre>private&nbsp;java.util.concurrent.atomic.AtomicInteger queuesize</pre>
</li>
</ul>
<a name="wsf">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>wsf</h4>
<pre>private&nbsp;<a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server">WebSocketServer.WebSocketServerFactory</a> wsf</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="WebSocketServer()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketServer</h4>
<pre>public&nbsp;WebSocketServer()
                throws java.net.UnknownHostException</pre>
<div class="block">Creates a WebSocketServer that will attempt to
 listen on port <var>WebSocket.DEFAULT_PORT</var>.</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.net.UnknownHostException</code></dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)"><code>more details here</code></a></dd></dl>
</li>
</ul>
<a name="WebSocketServer(java.net.InetSocketAddress)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketServer</h4>
<pre>public&nbsp;WebSocketServer(java.net.InetSocketAddress&nbsp;address)</pre>
<div class="block">Creates a WebSocketServer that will attempt to bind/listen on the given <var>address</var>.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)"><code>more details here</code></a></dd></dl>
</li>
</ul>
<a name="WebSocketServer(java.net.InetSocketAddress, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketServer</h4>
<pre>public&nbsp;WebSocketServer(java.net.InetSocketAddress&nbsp;address,
               int&nbsp;decoders)</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)"><code>more details here</code></a></dd></dl>
</li>
</ul>
<a name="WebSocketServer(java.net.InetSocketAddress, java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketServer</h4>
<pre>public&nbsp;WebSocketServer(java.net.InetSocketAddress&nbsp;address,
               java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts)</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)"><code>more details here</code></a></dd></dl>
</li>
</ul>
<a name="WebSocketServer(java.net.InetSocketAddress, int, java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketServer</h4>
<pre>public&nbsp;WebSocketServer(java.net.InetSocketAddress&nbsp;address,
               int&nbsp;decodercount,
               java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts)</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)"><code>more details here</code></a></dd></dl>
</li>
</ul>
<a name="WebSocketServer(java.net.InetSocketAddress, int, java.util.List, java.util.Collection)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>WebSocketServer</h4>
<pre>public&nbsp;WebSocketServer(java.net.InetSocketAddress&nbsp;address,
               int&nbsp;decodercount,
               java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts,
               java.util.Collection&lt;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&gt;&nbsp;connectionscontainer)</pre>
<div class="block">Creates a WebSocketServer that will attempt to bind/listen on the given <var>address</var>,
 and comply with <tt>Draft</tt> version <var>draft</var>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>address</code> - The address (host:port) this server should listen on.</dd><dd><code>decodercount</code> - The number of <a href="../../../org/java_websocket/server/WebSocketServer.WebSocketWorker.html" title="class in org.java_websocket.server"><code>WebSocketServer.WebSocketWorker</code></a>s that will be used to process the incoming network data. By default this will be <code>Runtime.getRuntime().availableProcessors()</code></dd><dd><code>drafts</code> - The versions of the WebSocket protocol that this server
            instance should comply to. Clients that use an other protocol version will be rejected.</dd><dd><code>connectionscontainer</code> - Allows to specify a collection that will be used to store the websockets in. <br>
            If you plan to often iterate through the currently connected websockets you may want to use a collection that does not require synchronization like a <code>CopyOnWriteArraySet</code>. In that case make sure that you overload <a href="../../../org/java_websocket/server/WebSocketServer.html#removeConnection(org.java_websocket.WebSocket)"><code>removeConnection(WebSocket)</code></a> and <a href="../../../org/java_websocket/server/WebSocketServer.html#addConnection(org.java_websocket.WebSocket)"><code>addConnection(WebSocket)</code></a>.<br>
            By default a <code>HashSet</code> will be used.</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#removeConnection(org.java_websocket.WebSocket)"><code>for more control over syncronized operation</code></a>, 
<a href="https://github.com/TooTallNate/Java-WebSocket/wiki/Drafts" > more about drafts</dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="start()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>start</h4>
<pre>public&nbsp;void&nbsp;start()</pre>
<div class="block">Starts the server selectorthread that binds to the currently set port number and
 listeners for WebSocket connection requests. Creates a fixed thread pool with the size <a href="../../../org/java_websocket/server/WebSocketServer.html#DECODERS"><code>DECODERS</code></a><br>
 May only be called once.
 
 Alternatively you can call <a href="../../../org/java_websocket/server/WebSocketServer.html#run()"><code>run()</code></a> directly.</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.IllegalStateException</code></dd></dl>
</li>
</ul>
<a name="stop(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>stop</h4>
<pre>public&nbsp;void&nbsp;stop(int&nbsp;timeout)
          throws java.lang.InterruptedException</pre>
<div class="block">Closes all connected clients sockets, then closes the underlying
 ServerSocketChannel, effectively killing the server socket selectorthread,
 freeing the port the server was bound to and stops all internal workerthreads.
 
 If this method is called before the server is started it will never start.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>timeout</code> - Specifies how many milliseconds the overall close handshaking may take altogether before the connections are closed without proper close handshaking.<br></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - When <code>ServerSocketChannel</code>.close throws an IOException</dd>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="stop()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>stop</h4>
<pre>public&nbsp;void&nbsp;stop()
          throws java.io.IOException,
                 java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="connections()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connections</h4>
<pre>public&nbsp;java.util.Collection&lt;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&gt;&nbsp;connections()</pre>
<div class="block">Returns a WebSocket[] of currently connected clients.
 Its iterators will be failfast and its not judicious
 to modify it.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The currently connected clients.</dd></dl>
</li>
</ul>
<a name="getAddress()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getAddress()</pre>
</li>
</ul>
<a name="getPort()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPort</h4>
<pre>public&nbsp;int&nbsp;getPort()</pre>
<div class="block">Gets the port number that this server listens on.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The port number.</dd></dl>
</li>
</ul>
<a name="getDraft()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDraft</h4>
<pre>public&nbsp;java.util.List&lt;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;getDraft()</pre>
</li>
</ul>
<a name="run()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>run</h4>
<pre>public&nbsp;void&nbsp;run()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>run</code>&nbsp;in interface&nbsp;<code>java.lang.Runnable</code></dd>
</dl>
</li>
</ul>
<a name="allocateBuffers(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>allocateBuffers</h4>
<pre>protected&nbsp;void&nbsp;allocateBuffers(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;c)
                        throws java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="releaseBuffers(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>releaseBuffers</h4>
<pre>protected&nbsp;void&nbsp;releaseBuffers(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;c)
                       throws java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="createBuffer()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createBuffer</h4>
<pre>public&nbsp;java.nio.ByteBuffer&nbsp;createBuffer()</pre>
</li>
</ul>
<a name="queue(org.java_websocket.WebSocketImpl)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>queue</h4>
<pre>private&nbsp;void&nbsp;queue(<a href="../../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket">WebSocketImpl</a>&nbsp;ws)
            throws java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="takeBuffer()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>takeBuffer</h4>
<pre>private&nbsp;java.nio.ByteBuffer&nbsp;takeBuffer()
                                throws java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="pushBuffer(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>pushBuffer</h4>
<pre>private&nbsp;void&nbsp;pushBuffer(java.nio.ByteBuffer&nbsp;buf)
                 throws java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="handleIOException(java.nio.channels.SelectionKey, org.java_websocket.WebSocket, java.io.IOException)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handleIOException</h4>
<pre>private&nbsp;void&nbsp;handleIOException(java.nio.channels.SelectionKey&nbsp;key,
                     <a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                     java.io.IOException&nbsp;ex)</pre>
</li>
</ul>
<a name="handleFatal(org.java_websocket.WebSocket, java.lang.Exception)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handleFatal</h4>
<pre>private&nbsp;void&nbsp;handleFatal(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
               java.lang.Exception&nbsp;e)</pre>
</li>
</ul>
<a name="getFlashSecurityPolicy()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFlashSecurityPolicy</h4>
<pre>protected&nbsp;java.lang.String&nbsp;getFlashSecurityPolicy()</pre>
<div class="block">Gets the XML string that should be returned if a client requests a Flash
 security policy.
 
 The default implementation allows access from all remote domains, but
 only on the port that this WebSocketServer is listening on.
 
 This is specifically implemented for gitime's WebSocket client for Flash:
 http://github.com/gimite/web-socket-js</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>An XML String that comforms to Flash's security policy. You MUST
         not include the null char at the end, it is appended automatically.</dd></dl>
</li>
</ul>
<a name="onWebsocketMessage(org.java_websocket.WebSocket, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessage</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketMessage(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      java.lang.String&nbsp;message)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.lang.String)">WebSocketListener</a></code></strong></div>
<div class="block">Called when an entire text frame has been received. Do whatever you want
 here...</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.lang.String)">onWebsocketMessage</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occurring on.</dd><dd><code>message</code> - The UTF-8 decoded message that was received.</dd></dl>
</li>
</ul>
<a name="onWebsocketMessageFragment(org.java_websocket.WebSocket, org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessageFragment</h4>
<pre>@Deprecated
public&nbsp;void&nbsp;onWebsocketMessageFragment(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                         <a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</pre>
<div class="block"><span class="strong">Deprecated.</span>&nbsp;</div>
<div class="block"><strong>Description copied from class:&nbsp;<code><a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">WebSocketAdapter</a></code></strong></div>
<div class="block">This default implementation does not do anything. Go ahead and overwrite it</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><strong>Overrides:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></code>&nbsp;in class&nbsp;<code><a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a></code></dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)"><code>WebSocketListener.onWebsocketMessageFragment(WebSocket, Framedata)</code></a></dd></dl>
</li>
</ul>
<a name="onWebsocketMessage(org.java_websocket.WebSocket, java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessage</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketMessage(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      java.nio.ByteBuffer&nbsp;blob)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">WebSocketListener</a></code></strong></div>
<div class="block">Called when an entire binary frame has been received. Do whatever you want
 here...</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">onWebsocketMessage</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occurring on.</dd><dd><code>blob</code> - The binary message that was received.</dd></dl>
</li>
</ul>
<a name="onWebsocketOpen(org.java_websocket.WebSocket, org.java_websocket.handshake.Handshakedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketOpen</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketOpen(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                   <a href="../../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;handshake)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.Handshakedata)">WebSocketListener</a></code></strong></div>
<div class="block">Called after <var>onHandshakeReceived</var> returns <var>true</var>.
 Indicates that a complete WebSocket connection has been established,
 and we are ready to send/receive data.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.Handshakedata)">onWebsocketOpen</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occuring on.</dd></dl>
</li>
</ul>
<a name="onWebsocketClose(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketClose</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketClose(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                    int&nbsp;code,
                    java.lang.String&nbsp;reason,
                    boolean&nbsp;remote)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">WebSocketListener</a></code></strong></div>
<div class="block">Called after <tt>WebSocket#close</tt> is explicity called, or when the
 other end of the WebSocket connection is closed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClose</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="removeConnection(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeConnection</h4>
<pre>protected&nbsp;boolean&nbsp;removeConnection(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws)</pre>
<div class="block">This method performs remove operations on the connection and therefore also gives control over whether the operation shall be synchronized
 <p>
 <a href="../../../org/java_websocket/server/WebSocketServer.html#WebSocketServer(java.net.InetSocketAddress,%20int,%20java.util.List,%20java.util.Collection)"><code>WebSocketServer(InetSocketAddress, int, List, Collection)</code></a> allows to specify a collection which will be used to store current connections in.<br>
 Depending on the type on the connection, modifications of that collection may have to be synchronized.</div>
</li>
</ul>
<a name="onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket, org.java_websocket.drafts.Draft, org.java_websocket.handshake.ClientHandshake)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketHandshakeReceivedAsServer</h4>
<pre>public&nbsp;<a href="../../../org/java_websocket/handshake/ServerHandshakeBuilder.html" title="interface in org.java_websocket.handshake">ServerHandshakeBuilder</a>&nbsp;onWebsocketHandshakeReceivedAsServer(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                                          <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft,
                                                          <a href="../../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request)
                                                            throws <a href="../../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></pre>
<div class="block"><strong>Description copied from class:&nbsp;<code><a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)">WebSocketAdapter</a></code></strong></div>
<div class="block">This default implementation does not do anything. Go ahead and overwrite it.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeReceivedAsServer</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><strong>Overrides:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeReceivedAsServer</a></code>&nbsp;in class&nbsp;<code><a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The WebSocket related to this event</dd><dd><code>draft</code> - The protocol draft the client uses to connect</dd><dd><code>request</code> - The opening http message send by the client. Can be used to access additional fields like cookies.</dd>
<dt><span class="strong">Returns:</span></dt><dd>Returns an incomplete handshake containing all optional fields</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></code> - Throwing this exception will cause this handshake to be rejected</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)"><code>WebSocketListener.onWebsocketHandshakeReceivedAsServer(WebSocket, Draft, ClientHandshake)</code></a></dd></dl>
</li>
</ul>
<a name="addConnection(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addConnection</h4>
<pre>protected&nbsp;boolean&nbsp;addConnection(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws)</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#removeConnection(org.java_websocket.WebSocket)"><code>removeConnection(WebSocket)</code></a></dd></dl>
</li>
</ul>
<a name="onWebsocketError(org.java_websocket.WebSocket, java.lang.Exception)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketError</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketError(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                    java.lang.Exception&nbsp;ex)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketError(org.java_websocket.WebSocket,%20java.lang.Exception)">WebSocketListener</a></code></strong></div>
<div class="block">Called if an exception worth noting occurred.
 If an error causes the connection to fail onClose will be called additionally afterwards.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketError(org.java_websocket.WebSocket,%20java.lang.Exception)">onWebsocketError</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - may be null if the error does not belong to a single connection</dd><dd><code>ex</code> - The exception that occurred. <br>
            Might be null if the exception is not related to any specific connection. For example if the server port could not be bound.</dd></dl>
</li>
</ul>
<a name="onWriteDemand(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWriteDemand</h4>
<pre>public final&nbsp;void&nbsp;onWriteDemand(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;w)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWriteDemand(org.java_websocket.WebSocket)">WebSocketListener</a></code></strong></div>
<div class="block">This method is used to inform the selector thread that there is data queued to be written to the socket.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWriteDemand(org.java_websocket.WebSocket)">onWriteDemand</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onWebsocketCloseInitiated(org.java_websocket.WebSocket, int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketCloseInitiated</h4>
<pre>public&nbsp;void&nbsp;onWebsocketCloseInitiated(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                             int&nbsp;code,
                             java.lang.String&nbsp;reason)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">WebSocketListener</a></code></strong></div>
<div class="block">send when this peer sends a close handshake</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">onWebsocketCloseInitiated</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onWebsocketClosing(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketClosing</h4>
<pre>public&nbsp;void&nbsp;onWebsocketClosing(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      int&nbsp;code,
                      java.lang.String&nbsp;reason,
                      boolean&nbsp;remote)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">WebSocketListener</a></code></strong></div>
<div class="block">called as soon as no further frames are accepted</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClosing</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onCloseInitiated(org.java_websocket.WebSocket, int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onCloseInitiated</h4>
<pre>public&nbsp;void&nbsp;onCloseInitiated(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                    int&nbsp;code,
                    java.lang.String&nbsp;reason)</pre>
</li>
</ul>
<a name="onClosing(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onClosing</h4>
<pre>public&nbsp;void&nbsp;onClosing(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
             int&nbsp;code,
             java.lang.String&nbsp;reason,
             boolean&nbsp;remote)</pre>
</li>
</ul>
<a name="setWebSocketFactory(org.java_websocket.server.WebSocketServer.WebSocketServerFactory)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setWebSocketFactory</h4>
<pre>public final&nbsp;void&nbsp;setWebSocketFactory(<a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server">WebSocketServer.WebSocketServerFactory</a>&nbsp;wsf)</pre>
</li>
</ul>
<a name="getWebSocketFactory()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWebSocketFactory</h4>
<pre>public final&nbsp;<a href="../../../org/java_websocket/WebSocketFactory.html" title="interface in org.java_websocket">WebSocketFactory</a>&nbsp;getWebSocketFactory()</pre>
</li>
</ul>
<a name="onConnect(java.nio.channels.SelectionKey)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onConnect</h4>
<pre>protected&nbsp;boolean&nbsp;onConnect(java.nio.channels.SelectionKey&nbsp;key)</pre>
<div class="block">Returns whether a new connection shall be accepted or not.<br>
 Therefore method is well suited to implement some kind of connection limitation.<br></div>
<dl><dt><span class="strong">See Also:</span></dt><dd><code>#onOpen(WebSocket, ClientHandshake)}, {@link #onWebsocketHandshakeReceivedAsServer(WebSocket, Draft, ClientHandshake)}</code></dd></dl>
</li>
</ul>
<a name="getSocket(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSocket</h4>
<pre>private&nbsp;java.net.Socket&nbsp;getSocket(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
</li>
</ul>
<a name="getLocalSocketAddress(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLocalSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getLocalSocketAddress(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#getLocalSocketAddress(org.java_websocket.WebSocket)">getLocalSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="getRemoteSocketAddress(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRemoteSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getRemoteSocketAddress(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#getRemoteSocketAddress(org.java_websocket.WebSocket)">getRemoteSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onOpen(org.java_websocket.WebSocket, org.java_websocket.handshake.ClientHandshake)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onOpen</h4>
<pre>public abstract&nbsp;void&nbsp;onOpen(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
          <a href="../../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;handshake)</pre>
<div class="block">Called after an opening handshake has been performed and the given websocket is ready to be written on.</div>
</li>
</ul>
<a name="onClose(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onClose</h4>
<pre>public abstract&nbsp;void&nbsp;onClose(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
           int&nbsp;code,
           java.lang.String&nbsp;reason,
           boolean&nbsp;remote)</pre>
<div class="block">Called after the websocket connection has been closed.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>code</code> - The codes can be looked up here: <a href="../../../org/java_websocket/framing/CloseFrame.html" title="interface in org.java_websocket.framing"><code>CloseFrame</code></a></dd><dd><code>reason</code> - Additional information string</dd><dd><code>remote</code> - Returns whether or not the closing of the connection was initiated by the remote host.</dd></dl>
</li>
</ul>
<a name="onMessage(org.java_websocket.WebSocket, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onMessage</h4>
<pre>public abstract&nbsp;void&nbsp;onMessage(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
             java.lang.String&nbsp;message)</pre>
<div class="block">Callback for string messages received from the remote host</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#onMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)"><code>onMessage(WebSocket, ByteBuffer)</code></a></dd></dl>
</li>
</ul>
<a name="onError(org.java_websocket.WebSocket, java.lang.Exception)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onError</h4>
<pre>public abstract&nbsp;void&nbsp;onError(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
           java.lang.Exception&nbsp;ex)</pre>
<div class="block">Called when errors occurs. If an error causes the websocket connection to fail <a href="../../../org/java_websocket/server/WebSocketServer.html#onClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)"><code>onClose(WebSocket, int, String, boolean)</code></a> will be called additionally.<br>
 This method will be called primarily because of IO or protocol errors.<br>
 If the given exception is an RuntimeException that probably means that you encountered a bug.<br></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>con</code> - Can be null if there error does not belong to one specific websocket. For example if the servers port could not be bound.</dd></dl>
</li>
</ul>
<a name="onMessage(org.java_websocket.WebSocket, java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onMessage</h4>
<pre>public&nbsp;void&nbsp;onMessage(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
             java.nio.ByteBuffer&nbsp;message)</pre>
<div class="block">Callback for binary messages received from the remote host</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/server/WebSocketServer.html#onMessage(org.java_websocket.WebSocket,%20java.lang.String)"><code>onMessage(WebSocket, String)</code></a></dd></dl>
</li>
</ul>
<a name="onFragment(org.java_websocket.WebSocket, org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>onFragment</h4>
<pre>public&nbsp;void&nbsp;onFragment(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
              <a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;fragment)</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/WebSocket.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)"><code>WebSocket.sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode, ByteBuffer, boolean)</code></a></dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketServer.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/java_websocket/server/DefaultWebSocketServerFactory.html" title="class in org.java_websocket.server"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/java_websocket/server/WebSocketServer.WebSocketServerFactory.html" title="interface in org.java_websocket.server"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/server/WebSocketServer.html" target="_top">Frames</a></li>
<li><a href="WebSocketServer.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
